/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.2
        Device            :  PIC16F18875
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.20 and above
        MPLAB 	          :  MPLAB X 5.40	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set BANK2_ODD aliases
#define BANK2_ODD_TRIS                 TRISAbits.TRISA0
#define BANK2_ODD_LAT                  LATAbits.LATA0
#define BANK2_ODD_PORT                 PORTAbits.RA0
#define BANK2_ODD_WPU                  WPUAbits.WPUA0
#define BANK2_ODD_OD                   ODCONAbits.ODCA0
#define BANK2_ODD_ANS                  ANSELAbits.ANSA0
#define BANK2_ODD_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define BANK2_ODD_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define BANK2_ODD_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define BANK2_ODD_GetValue()           PORTAbits.RA0
#define BANK2_ODD_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define BANK2_ODD_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define BANK2_ODD_SetPullup()          do { WPUAbits.WPUA0 = 1; } while(0)
#define BANK2_ODD_ResetPullup()        do { WPUAbits.WPUA0 = 0; } while(0)
#define BANK2_ODD_SetPushPull()        do { ODCONAbits.ODCA0 = 0; } while(0)
#define BANK2_ODD_SetOpenDrain()       do { ODCONAbits.ODCA0 = 1; } while(0)
#define BANK2_ODD_SetAnalogMode()      do { ANSELAbits.ANSA0 = 1; } while(0)
#define BANK2_ODD_SetDigitalMode()     do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set BANK2_EVEN aliases
#define BANK2_EVEN_TRIS                 TRISAbits.TRISA1
#define BANK2_EVEN_LAT                  LATAbits.LATA1
#define BANK2_EVEN_PORT                 PORTAbits.RA1
#define BANK2_EVEN_WPU                  WPUAbits.WPUA1
#define BANK2_EVEN_OD                   ODCONAbits.ODCA1
#define BANK2_EVEN_ANS                  ANSELAbits.ANSA1
#define BANK2_EVEN_SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define BANK2_EVEN_SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define BANK2_EVEN_Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define BANK2_EVEN_GetValue()           PORTAbits.RA1
#define BANK2_EVEN_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define BANK2_EVEN_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define BANK2_EVEN_SetPullup()          do { WPUAbits.WPUA1 = 1; } while(0)
#define BANK2_EVEN_ResetPullup()        do { WPUAbits.WPUA1 = 0; } while(0)
#define BANK2_EVEN_SetPushPull()        do { ODCONAbits.ODCA1 = 0; } while(0)
#define BANK2_EVEN_SetOpenDrain()       do { ODCONAbits.ODCA1 = 1; } while(0)
#define BANK2_EVEN_SetAnalogMode()      do { ANSELAbits.ANSA1 = 1; } while(0)
#define BANK2_EVEN_SetDigitalMode()     do { ANSELAbits.ANSA1 = 0; } while(0)

// get/set CHAN11_12 aliases
#define CHAN11_12_TRIS                 TRISAbits.TRISA2
#define CHAN11_12_LAT                  LATAbits.LATA2
#define CHAN11_12_PORT                 PORTAbits.RA2
#define CHAN11_12_WPU                  WPUAbits.WPUA2
#define CHAN11_12_OD                   ODCONAbits.ODCA2
#define CHAN11_12_ANS                  ANSELAbits.ANSA2
#define CHAN11_12_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define CHAN11_12_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define CHAN11_12_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define CHAN11_12_GetValue()           PORTAbits.RA2
#define CHAN11_12_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define CHAN11_12_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define CHAN11_12_SetPullup()          do { WPUAbits.WPUA2 = 1; } while(0)
#define CHAN11_12_ResetPullup()        do { WPUAbits.WPUA2 = 0; } while(0)
#define CHAN11_12_SetPushPull()        do { ODCONAbits.ODCA2 = 0; } while(0)
#define CHAN11_12_SetOpenDrain()       do { ODCONAbits.ODCA2 = 1; } while(0)
#define CHAN11_12_SetAnalogMode()      do { ANSELAbits.ANSA2 = 1; } while(0)
#define CHAN11_12_SetDigitalMode()     do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set CHAN13_14 aliases
#define CHAN13_14_TRIS                 TRISAbits.TRISA3
#define CHAN13_14_LAT                  LATAbits.LATA3
#define CHAN13_14_PORT                 PORTAbits.RA3
#define CHAN13_14_WPU                  WPUAbits.WPUA3
#define CHAN13_14_OD                   ODCONAbits.ODCA3
#define CHAN13_14_ANS                  ANSELAbits.ANSA3
#define CHAN13_14_SetHigh()            do { LATAbits.LATA3 = 1; } while(0)
#define CHAN13_14_SetLow()             do { LATAbits.LATA3 = 0; } while(0)
#define CHAN13_14_Toggle()             do { LATAbits.LATA3 = ~LATAbits.LATA3; } while(0)
#define CHAN13_14_GetValue()           PORTAbits.RA3
#define CHAN13_14_SetDigitalInput()    do { TRISAbits.TRISA3 = 1; } while(0)
#define CHAN13_14_SetDigitalOutput()   do { TRISAbits.TRISA3 = 0; } while(0)
#define CHAN13_14_SetPullup()          do { WPUAbits.WPUA3 = 1; } while(0)
#define CHAN13_14_ResetPullup()        do { WPUAbits.WPUA3 = 0; } while(0)
#define CHAN13_14_SetPushPull()        do { ODCONAbits.ODCA3 = 0; } while(0)
#define CHAN13_14_SetOpenDrain()       do { ODCONAbits.ODCA3 = 1; } while(0)
#define CHAN13_14_SetAnalogMode()      do { ANSELAbits.ANSA3 = 1; } while(0)
#define CHAN13_14_SetDigitalMode()     do { ANSELAbits.ANSA3 = 0; } while(0)

// get/set CHAN15_16 aliases
#define CHAN15_16_TRIS                 TRISAbits.TRISA4
#define CHAN15_16_LAT                  LATAbits.LATA4
#define CHAN15_16_PORT                 PORTAbits.RA4
#define CHAN15_16_WPU                  WPUAbits.WPUA4
#define CHAN15_16_OD                   ODCONAbits.ODCA4
#define CHAN15_16_ANS                  ANSELAbits.ANSA4
#define CHAN15_16_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define CHAN15_16_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define CHAN15_16_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define CHAN15_16_GetValue()           PORTAbits.RA4
#define CHAN15_16_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define CHAN15_16_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define CHAN15_16_SetPullup()          do { WPUAbits.WPUA4 = 1; } while(0)
#define CHAN15_16_ResetPullup()        do { WPUAbits.WPUA4 = 0; } while(0)
#define CHAN15_16_SetPushPull()        do { ODCONAbits.ODCA4 = 0; } while(0)
#define CHAN15_16_SetOpenDrain()       do { ODCONAbits.ODCA4 = 1; } while(0)
#define CHAN15_16_SetAnalogMode()      do { ANSELAbits.ANSA4 = 1; } while(0)
#define CHAN15_16_SetDigitalMode()     do { ANSELAbits.ANSA4 = 0; } while(0)

// get/set CHAN17_18 aliases
#define CHAN17_18_TRIS                 TRISAbits.TRISA5
#define CHAN17_18_LAT                  LATAbits.LATA5
#define CHAN17_18_PORT                 PORTAbits.RA5
#define CHAN17_18_WPU                  WPUAbits.WPUA5
#define CHAN17_18_OD                   ODCONAbits.ODCA5
#define CHAN17_18_ANS                  ANSELAbits.ANSA5
#define CHAN17_18_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define CHAN17_18_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define CHAN17_18_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define CHAN17_18_GetValue()           PORTAbits.RA5
#define CHAN17_18_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define CHAN17_18_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define CHAN17_18_SetPullup()          do { WPUAbits.WPUA5 = 1; } while(0)
#define CHAN17_18_ResetPullup()        do { WPUAbits.WPUA5 = 0; } while(0)
#define CHAN17_18_SetPushPull()        do { ODCONAbits.ODCA5 = 0; } while(0)
#define CHAN17_18_SetOpenDrain()       do { ODCONAbits.ODCA5 = 1; } while(0)
#define CHAN17_18_SetAnalogMode()      do { ANSELAbits.ANSA5 = 1; } while(0)
#define CHAN17_18_SetDigitalMode()     do { ANSELAbits.ANSA5 = 0; } while(0)

// get/set IO_RA6 aliases
#define IO_RA6_TRIS                 TRISAbits.TRISA6
#define IO_RA6_LAT                  LATAbits.LATA6
#define IO_RA6_PORT                 PORTAbits.RA6
#define IO_RA6_WPU                  WPUAbits.WPUA6
#define IO_RA6_OD                   ODCONAbits.ODCA6
#define IO_RA6_ANS                  ANSELAbits.ANSA6
#define IO_RA6_SetHigh()            do { LATAbits.LATA6 = 1; } while(0)
#define IO_RA6_SetLow()             do { LATAbits.LATA6 = 0; } while(0)
#define IO_RA6_Toggle()             do { LATAbits.LATA6 = ~LATAbits.LATA6; } while(0)
#define IO_RA6_GetValue()           PORTAbits.RA6
#define IO_RA6_SetDigitalInput()    do { TRISAbits.TRISA6 = 1; } while(0)
#define IO_RA6_SetDigitalOutput()   do { TRISAbits.TRISA6 = 0; } while(0)
#define IO_RA6_SetPullup()          do { WPUAbits.WPUA6 = 1; } while(0)
#define IO_RA6_ResetPullup()        do { WPUAbits.WPUA6 = 0; } while(0)
#define IO_RA6_SetPushPull()        do { ODCONAbits.ODCA6 = 0; } while(0)
#define IO_RA6_SetOpenDrain()       do { ODCONAbits.ODCA6 = 1; } while(0)
#define IO_RA6_SetAnalogMode()      do { ANSELAbits.ANSA6 = 1; } while(0)
#define IO_RA6_SetDigitalMode()     do { ANSELAbits.ANSA6 = 0; } while(0)

// get/set TWO_WIRE_ENn aliases
#define TWO_WIRE_ENn_TRIS                 TRISAbits.TRISA7
#define TWO_WIRE_ENn_LAT                  LATAbits.LATA7
#define TWO_WIRE_ENn_PORT                 PORTAbits.RA7
#define TWO_WIRE_ENn_WPU                  WPUAbits.WPUA7
#define TWO_WIRE_ENn_OD                   ODCONAbits.ODCA7
#define TWO_WIRE_ENn_ANS                  ANSELAbits.ANSA7
#define TWO_WIRE_ENn_SetHigh()            do { LATAbits.LATA7 = 1; } while(0)
#define TWO_WIRE_ENn_SetLow()             do { LATAbits.LATA7 = 0; } while(0)
#define TWO_WIRE_ENn_Toggle()             do { LATAbits.LATA7 = ~LATAbits.LATA7; } while(0)
#define TWO_WIRE_ENn_GetValue()           PORTAbits.RA7
#define TWO_WIRE_ENn_SetDigitalInput()    do { TRISAbits.TRISA7 = 1; } while(0)
#define TWO_WIRE_ENn_SetDigitalOutput()   do { TRISAbits.TRISA7 = 0; } while(0)
#define TWO_WIRE_ENn_SetPullup()          do { WPUAbits.WPUA7 = 1; } while(0)
#define TWO_WIRE_ENn_ResetPullup()        do { WPUAbits.WPUA7 = 0; } while(0)
#define TWO_WIRE_ENn_SetPushPull()        do { ODCONAbits.ODCA7 = 0; } while(0)
#define TWO_WIRE_ENn_SetOpenDrain()       do { ODCONAbits.ODCA7 = 1; } while(0)
#define TWO_WIRE_ENn_SetAnalogMode()      do { ANSELAbits.ANSA7 = 1; } while(0)
#define TWO_WIRE_ENn_SetDigitalMode()     do { ANSELAbits.ANSA7 = 0; } while(0)

// get/set DMM_MODE_10_20 aliases
#define DMM_MODE_10_20_TRIS                 TRISBbits.TRISB0
#define DMM_MODE_10_20_LAT                  LATBbits.LATB0
#define DMM_MODE_10_20_PORT                 PORTBbits.RB0
#define DMM_MODE_10_20_WPU                  WPUBbits.WPUB0
#define DMM_MODE_10_20_OD                   ODCONBbits.ODCB0
#define DMM_MODE_10_20_ANS                  ANSELBbits.ANSB0
#define DMM_MODE_10_20_SetHigh()            do { LATBbits.LATB0 = 1; } while(0)
#define DMM_MODE_10_20_SetLow()             do { LATBbits.LATB0 = 0; } while(0)
#define DMM_MODE_10_20_Toggle()             do { LATBbits.LATB0 = ~LATBbits.LATB0; } while(0)
#define DMM_MODE_10_20_GetValue()           PORTBbits.RB0
#define DMM_MODE_10_20_SetDigitalInput()    do { TRISBbits.TRISB0 = 1; } while(0)
#define DMM_MODE_10_20_SetDigitalOutput()   do { TRISBbits.TRISB0 = 0; } while(0)
#define DMM_MODE_10_20_SetPullup()          do { WPUBbits.WPUB0 = 1; } while(0)
#define DMM_MODE_10_20_ResetPullup()        do { WPUBbits.WPUB0 = 0; } while(0)
#define DMM_MODE_10_20_SetPushPull()        do { ODCONBbits.ODCB0 = 0; } while(0)
#define DMM_MODE_10_20_SetOpenDrain()       do { ODCONBbits.ODCB0 = 1; } while(0)
#define DMM_MODE_10_20_SetAnalogMode()      do { ANSELBbits.ANSB0 = 1; } while(0)
#define DMM_MODE_10_20_SetDigitalMode()     do { ANSELBbits.ANSB0 = 0; } while(0)

// get/set DMM_RESET aliases
#define DMM_RESET_TRIS                 TRISBbits.TRISB1
#define DMM_RESET_LAT                  LATBbits.LATB1
#define DMM_RESET_PORT                 PORTBbits.RB1
#define DMM_RESET_WPU                  WPUBbits.WPUB1
#define DMM_RESET_OD                   ODCONBbits.ODCB1
#define DMM_RESET_ANS                  ANSELBbits.ANSB1
#define DMM_RESET_SetHigh()            do { LATBbits.LATB1 = 1; } while(0)
#define DMM_RESET_SetLow()             do { LATBbits.LATB1 = 0; } while(0)
#define DMM_RESET_Toggle()             do { LATBbits.LATB1 = ~LATBbits.LATB1; } while(0)
#define DMM_RESET_GetValue()           PORTBbits.RB1
#define DMM_RESET_SetDigitalInput()    do { TRISBbits.TRISB1 = 1; } while(0)
#define DMM_RESET_SetDigitalOutput()   do { TRISBbits.TRISB1 = 0; } while(0)
#define DMM_RESET_SetPullup()          do { WPUBbits.WPUB1 = 1; } while(0)
#define DMM_RESET_ResetPullup()        do { WPUBbits.WPUB1 = 0; } while(0)
#define DMM_RESET_SetPushPull()        do { ODCONBbits.ODCB1 = 0; } while(0)
#define DMM_RESET_SetOpenDrain()       do { ODCONBbits.ODCB1 = 1; } while(0)
#define DMM_RESET_SetAnalogMode()      do { ANSELBbits.ANSB1 = 1; } while(0)
#define DMM_RESET_SetDigitalMode()     do { ANSELBbits.ANSB1 = 0; } while(0)

// get/set TP1 aliases
#define TP1_TRIS                 TRISBbits.TRISB2
#define TP1_LAT                  LATBbits.LATB2
#define TP1_PORT                 PORTBbits.RB2
#define TP1_WPU                  WPUBbits.WPUB2
#define TP1_OD                   ODCONBbits.ODCB2
#define TP1_ANS                  ANSELBbits.ANSB2
#define TP1_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define TP1_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define TP1_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define TP1_GetValue()           PORTBbits.RB2
#define TP1_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define TP1_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define TP1_SetPullup()          do { WPUBbits.WPUB2 = 1; } while(0)
#define TP1_ResetPullup()        do { WPUBbits.WPUB2 = 0; } while(0)
#define TP1_SetPushPull()        do { ODCONBbits.ODCB2 = 0; } while(0)
#define TP1_SetOpenDrain()       do { ODCONBbits.ODCB2 = 1; } while(0)
#define TP1_SetAnalogMode()      do { ANSELBbits.ANSB2 = 1; } while(0)
#define TP1_SetDigitalMode()     do { ANSELBbits.ANSB2 = 0; } while(0)

// get/set TP2 aliases
#define TP2_TRIS                 TRISBbits.TRISB3
#define TP2_LAT                  LATBbits.LATB3
#define TP2_PORT                 PORTBbits.RB3
#define TP2_WPU                  WPUBbits.WPUB3
#define TP2_OD                   ODCONBbits.ODCB3
#define TP2_ANS                  ANSELBbits.ANSB3
#define TP2_SetHigh()            do { LATBbits.LATB3 = 1; } while(0)
#define TP2_SetLow()             do { LATBbits.LATB3 = 0; } while(0)
#define TP2_Toggle()             do { LATBbits.LATB3 = ~LATBbits.LATB3; } while(0)
#define TP2_GetValue()           PORTBbits.RB3
#define TP2_SetDigitalInput()    do { TRISBbits.TRISB3 = 1; } while(0)
#define TP2_SetDigitalOutput()   do { TRISBbits.TRISB3 = 0; } while(0)
#define TP2_SetPullup()          do { WPUBbits.WPUB3 = 1; } while(0)
#define TP2_ResetPullup()        do { WPUBbits.WPUB3 = 0; } while(0)
#define TP2_SetPushPull()        do { ODCONBbits.ODCB3 = 0; } while(0)
#define TP2_SetOpenDrain()       do { ODCONBbits.ODCB3 = 1; } while(0)
#define TP2_SetAnalogMode()      do { ANSELBbits.ANSB3 = 1; } while(0)
#define TP2_SetDigitalMode()     do { ANSELBbits.ANSB3 = 0; } while(0)

// get/set TP3 aliases
#define TP3_TRIS                 TRISBbits.TRISB4
#define TP3_LAT                  LATBbits.LATB4
#define TP3_PORT                 PORTBbits.RB4
#define TP3_WPU                  WPUBbits.WPUB4
#define TP3_OD                   ODCONBbits.ODCB4
#define TP3_ANS                  ANSELBbits.ANSB4
#define TP3_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define TP3_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define TP3_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define TP3_GetValue()           PORTBbits.RB4
#define TP3_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define TP3_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define TP3_SetPullup()          do { WPUBbits.WPUB4 = 1; } while(0)
#define TP3_ResetPullup()        do { WPUBbits.WPUB4 = 0; } while(0)
#define TP3_SetPushPull()        do { ODCONBbits.ODCB4 = 0; } while(0)
#define TP3_SetOpenDrain()       do { ODCONBbits.ODCB4 = 1; } while(0)
#define TP3_SetAnalogMode()      do { ANSELBbits.ANSB4 = 1; } while(0)
#define TP3_SetDigitalMode()     do { ANSELBbits.ANSB4 = 0; } while(0)

// get/set CHAN9_10 aliases
#define CHAN9_10_TRIS                 TRISBbits.TRISB5
#define CHAN9_10_LAT                  LATBbits.LATB5
#define CHAN9_10_PORT                 PORTBbits.RB5
#define CHAN9_10_WPU                  WPUBbits.WPUB5
#define CHAN9_10_OD                   ODCONBbits.ODCB5
#define CHAN9_10_ANS                  ANSELBbits.ANSB5
#define CHAN9_10_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define CHAN9_10_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define CHAN9_10_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define CHAN9_10_GetValue()           PORTBbits.RB5
#define CHAN9_10_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define CHAN9_10_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)
#define CHAN9_10_SetPullup()          do { WPUBbits.WPUB5 = 1; } while(0)
#define CHAN9_10_ResetPullup()        do { WPUBbits.WPUB5 = 0; } while(0)
#define CHAN9_10_SetPushPull()        do { ODCONBbits.ODCB5 = 0; } while(0)
#define CHAN9_10_SetOpenDrain()       do { ODCONBbits.ODCB5 = 1; } while(0)
#define CHAN9_10_SetAnalogMode()      do { ANSELBbits.ANSB5 = 1; } while(0)
#define CHAN9_10_SetDigitalMode()     do { ANSELBbits.ANSB5 = 0; } while(0)

// get/set IO_RB6_PGC aliases
#define IO_RB6_PGC_TRIS                 TRISBbits.TRISB6
#define IO_RB6_PGC_LAT                  LATBbits.LATB6
#define IO_RB6_PGC_PORT                 PORTBbits.RB6
#define IO_RB6_PGC_WPU                  WPUBbits.WPUB6
#define IO_RB6_PGC_OD                   ODCONBbits.ODCB6
#define IO_RB6_PGC_ANS                  ANSELBbits.ANSB6
#define IO_RB6_PGC_SetHigh()            do { LATBbits.LATB6 = 1; } while(0)
#define IO_RB6_PGC_SetLow()             do { LATBbits.LATB6 = 0; } while(0)
#define IO_RB6_PGC_Toggle()             do { LATBbits.LATB6 = ~LATBbits.LATB6; } while(0)
#define IO_RB6_PGC_GetValue()           PORTBbits.RB6
#define IO_RB6_PGC_SetDigitalInput()    do { TRISBbits.TRISB6 = 1; } while(0)
#define IO_RB6_PGC_SetDigitalOutput()   do { TRISBbits.TRISB6 = 0; } while(0)
#define IO_RB6_PGC_SetPullup()          do { WPUBbits.WPUB6 = 1; } while(0)
#define IO_RB6_PGC_ResetPullup()        do { WPUBbits.WPUB6 = 0; } while(0)
#define IO_RB6_PGC_SetPushPull()        do { ODCONBbits.ODCB6 = 0; } while(0)
#define IO_RB6_PGC_SetOpenDrain()       do { ODCONBbits.ODCB6 = 1; } while(0)
#define IO_RB6_PGC_SetAnalogMode()      do { ANSELBbits.ANSB6 = 1; } while(0)
#define IO_RB6_PGC_SetDigitalMode()     do { ANSELBbits.ANSB6 = 0; } while(0)

// get/set IO_RB7_PGD aliases
#define IO_RB7_PGD_TRIS                 TRISBbits.TRISB7
#define IO_RB7_PGD_LAT                  LATBbits.LATB7
#define IO_RB7_PGD_PORT                 PORTBbits.RB7
#define IO_RB7_PGD_WPU                  WPUBbits.WPUB7
#define IO_RB7_PGD_OD                   ODCONBbits.ODCB7
#define IO_RB7_PGD_ANS                  ANSELBbits.ANSB7
#define IO_RB7_PGD_SetHigh()            do { LATBbits.LATB7 = 1; } while(0)
#define IO_RB7_PGD_SetLow()             do { LATBbits.LATB7 = 0; } while(0)
#define IO_RB7_PGD_Toggle()             do { LATBbits.LATB7 = ~LATBbits.LATB7; } while(0)
#define IO_RB7_PGD_GetValue()           PORTBbits.RB7
#define IO_RB7_PGD_SetDigitalInput()    do { TRISBbits.TRISB7 = 1; } while(0)
#define IO_RB7_PGD_SetDigitalOutput()   do { TRISBbits.TRISB7 = 0; } while(0)
#define IO_RB7_PGD_SetPullup()          do { WPUBbits.WPUB7 = 1; } while(0)
#define IO_RB7_PGD_ResetPullup()        do { WPUBbits.WPUB7 = 0; } while(0)
#define IO_RB7_PGD_SetPushPull()        do { ODCONBbits.ODCB7 = 0; } while(0)
#define IO_RB7_PGD_SetOpenDrain()       do { ODCONBbits.ODCB7 = 1; } while(0)
#define IO_RB7_PGD_SetAnalogMode()      do { ANSELBbits.ANSB7 = 1; } while(0)
#define IO_RB7_PGD_SetDigitalMode()     do { ANSELBbits.ANSB7 = 0; } while(0)

// get/set IO_RC0 aliases
#define IO_RC0_TRIS                 TRISCbits.TRISC0
#define IO_RC0_LAT                  LATCbits.LATC0
#define IO_RC0_PORT                 PORTCbits.RC0
#define IO_RC0_WPU                  WPUCbits.WPUC0
#define IO_RC0_OD                   ODCONCbits.ODCC0
#define IO_RC0_ANS                  ANSELCbits.ANSC0
#define IO_RC0_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define IO_RC0_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define IO_RC0_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define IO_RC0_GetValue()           PORTCbits.RC0
#define IO_RC0_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define IO_RC0_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define IO_RC0_SetPullup()          do { WPUCbits.WPUC0 = 1; } while(0)
#define IO_RC0_ResetPullup()        do { WPUCbits.WPUC0 = 0; } while(0)
#define IO_RC0_SetPushPull()        do { ODCONCbits.ODCC0 = 0; } while(0)
#define IO_RC0_SetOpenDrain()       do { ODCONCbits.ODCC0 = 1; } while(0)
#define IO_RC0_SetAnalogMode()      do { ANSELCbits.ANSC0 = 1; } while(0)
#define IO_RC0_SetDigitalMode()     do { ANSELCbits.ANSC0 = 0; } while(0)

// get/set BANK1_EVEN aliases
#define BANK1_EVEN_TRIS                 TRISCbits.TRISC1
#define BANK1_EVEN_LAT                  LATCbits.LATC1
#define BANK1_EVEN_PORT                 PORTCbits.RC1
#define BANK1_EVEN_WPU                  WPUCbits.WPUC1
#define BANK1_EVEN_OD                   ODCONCbits.ODCC1
#define BANK1_EVEN_ANS                  ANSELCbits.ANSC1
#define BANK1_EVEN_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define BANK1_EVEN_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define BANK1_EVEN_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define BANK1_EVEN_GetValue()           PORTCbits.RC1
#define BANK1_EVEN_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define BANK1_EVEN_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define BANK1_EVEN_SetPullup()          do { WPUCbits.WPUC1 = 1; } while(0)
#define BANK1_EVEN_ResetPullup()        do { WPUCbits.WPUC1 = 0; } while(0)
#define BANK1_EVEN_SetPushPull()        do { ODCONCbits.ODCC1 = 0; } while(0)
#define BANK1_EVEN_SetOpenDrain()       do { ODCONCbits.ODCC1 = 1; } while(0)
#define BANK1_EVEN_SetAnalogMode()      do { ANSELCbits.ANSC1 = 1; } while(0)
#define BANK1_EVEN_SetDigitalMode()     do { ANSELCbits.ANSC1 = 0; } while(0)

// get/set BANK1_ODD aliases
#define BANK1_ODD_TRIS                 TRISCbits.TRISC2
#define BANK1_ODD_LAT                  LATCbits.LATC2
#define BANK1_ODD_PORT                 PORTCbits.RC2
#define BANK1_ODD_WPU                  WPUCbits.WPUC2
#define BANK1_ODD_OD                   ODCONCbits.ODCC2
#define BANK1_ODD_ANS                  ANSELCbits.ANSC2
#define BANK1_ODD_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define BANK1_ODD_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define BANK1_ODD_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define BANK1_ODD_GetValue()           PORTCbits.RC2
#define BANK1_ODD_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define BANK1_ODD_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define BANK1_ODD_SetPullup()          do { WPUCbits.WPUC2 = 1; } while(0)
#define BANK1_ODD_ResetPullup()        do { WPUCbits.WPUC2 = 0; } while(0)
#define BANK1_ODD_SetPushPull()        do { ODCONCbits.ODCC2 = 0; } while(0)
#define BANK1_ODD_SetOpenDrain()       do { ODCONCbits.ODCC2 = 1; } while(0)
#define BANK1_ODD_SetAnalogMode()      do { ANSELCbits.ANSC2 = 1; } while(0)
#define BANK1_ODD_SetDigitalMode()     do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set IO_RC3 aliases
#define IO_RC3_TRIS                 TRISCbits.TRISC3
#define IO_RC3_LAT                  LATCbits.LATC3
#define IO_RC3_PORT                 PORTCbits.RC3
#define IO_RC3_WPU                  WPUCbits.WPUC3
#define IO_RC3_OD                   ODCONCbits.ODCC3
#define IO_RC3_ANS                  ANSELCbits.ANSC3
#define IO_RC3_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define IO_RC3_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define IO_RC3_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define IO_RC3_GetValue()           PORTCbits.RC3
#define IO_RC3_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define IO_RC3_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define IO_RC3_SetPullup()          do { WPUCbits.WPUC3 = 1; } while(0)
#define IO_RC3_ResetPullup()        do { WPUCbits.WPUC3 = 0; } while(0)
#define IO_RC3_SetPushPull()        do { ODCONCbits.ODCC3 = 0; } while(0)
#define IO_RC3_SetOpenDrain()       do { ODCONCbits.ODCC3 = 1; } while(0)
#define IO_RC3_SetAnalogMode()      do { ANSELCbits.ANSC3 = 1; } while(0)
#define IO_RC3_SetDigitalMode()     do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set IO_RC4 aliases
#define IO_RC4_TRIS                 TRISCbits.TRISC4
#define IO_RC4_LAT                  LATCbits.LATC4
#define IO_RC4_PORT                 PORTCbits.RC4
#define IO_RC4_WPU                  WPUCbits.WPUC4
#define IO_RC4_OD                   ODCONCbits.ODCC4
#define IO_RC4_ANS                  ANSELCbits.ANSC4
#define IO_RC4_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define IO_RC4_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define IO_RC4_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define IO_RC4_GetValue()           PORTCbits.RC4
#define IO_RC4_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define IO_RC4_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define IO_RC4_SetPullup()          do { WPUCbits.WPUC4 = 1; } while(0)
#define IO_RC4_ResetPullup()        do { WPUCbits.WPUC4 = 0; } while(0)
#define IO_RC4_SetPushPull()        do { ODCONCbits.ODCC4 = 0; } while(0)
#define IO_RC4_SetOpenDrain()       do { ODCONCbits.ODCC4 = 1; } while(0)
#define IO_RC4_SetAnalogMode()      do { ANSELCbits.ANSC4 = 1; } while(0)
#define IO_RC4_SetDigitalMode()     do { ANSELCbits.ANSC4 = 0; } while(0)

// get/set STROBE_RC5 aliases
#define STROBE_RC5_TRIS                 TRISCbits.TRISC5
#define STROBE_RC5_LAT                  LATCbits.LATC5
#define STROBE_RC5_PORT                 PORTCbits.RC5
#define STROBE_RC5_WPU                  WPUCbits.WPUC5
#define STROBE_RC5_OD                   ODCONCbits.ODCC5
#define STROBE_RC5_ANS                  ANSELCbits.ANSC5
#define STROBE_RC5_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define STROBE_RC5_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define STROBE_RC5_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define STROBE_RC5_GetValue()           PORTCbits.RC5
#define STROBE_RC5_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define STROBE_RC5_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define STROBE_RC5_SetPullup()          do { WPUCbits.WPUC5 = 1; } while(0)
#define STROBE_RC5_ResetPullup()        do { WPUCbits.WPUC5 = 0; } while(0)
#define STROBE_RC5_SetPushPull()        do { ODCONCbits.ODCC5 = 0; } while(0)
#define STROBE_RC5_SetOpenDrain()       do { ODCONCbits.ODCC5 = 1; } while(0)
#define STROBE_RC5_SetAnalogMode()      do { ANSELCbits.ANSC5 = 1; } while(0)
#define STROBE_RC5_SetDigitalMode()     do { ANSELCbits.ANSC5 = 0; } while(0)

// get/set RC6 procedures
#define RC6_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define RC6_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define RC6_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define RC6_GetValue()              PORTCbits.RC6
#define RC6_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define RC6_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define RC6_SetPullup()             do { WPUCbits.WPUC6 = 1; } while(0)
#define RC6_ResetPullup()           do { WPUCbits.WPUC6 = 0; } while(0)
#define RC6_SetAnalogMode()         do { ANSELCbits.ANSC6 = 1; } while(0)
#define RC6_SetDigitalMode()        do { ANSELCbits.ANSC6 = 0; } while(0)

// get/set IO_RC7 aliases
#define IO_RC7_TRIS                 TRISCbits.TRISC7
#define IO_RC7_LAT                  LATCbits.LATC7
#define IO_RC7_PORT                 PORTCbits.RC7
#define IO_RC7_WPU                  WPUCbits.WPUC7
#define IO_RC7_OD                   ODCONCbits.ODCC7
#define IO_RC7_ANS                  ANSELCbits.ANSC7
#define IO_RC7_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define IO_RC7_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define IO_RC7_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define IO_RC7_GetValue()           PORTCbits.RC7
#define IO_RC7_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define IO_RC7_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define IO_RC7_SetPullup()          do { WPUCbits.WPUC7 = 1; } while(0)
#define IO_RC7_ResetPullup()        do { WPUCbits.WPUC7 = 0; } while(0)
#define IO_RC7_SetPushPull()        do { ODCONCbits.ODCC7 = 0; } while(0)
#define IO_RC7_SetOpenDrain()       do { ODCONCbits.ODCC7 = 1; } while(0)
#define IO_RC7_SetAnalogMode()      do { ANSELCbits.ANSC7 = 1; } while(0)
#define IO_RC7_SetDigitalMode()     do { ANSELCbits.ANSC7 = 0; } while(0)

// get/set CHAN7_8 aliases
#define CHAN7_8_TRIS                 TRISDbits.TRISD0
#define CHAN7_8_LAT                  LATDbits.LATD0
#define CHAN7_8_PORT                 PORTDbits.RD0
#define CHAN7_8_WPU                  WPUDbits.WPUD0
#define CHAN7_8_OD                   ODCONDbits.ODCD0
#define CHAN7_8_ANS                  ANSELDbits.ANSD0
#define CHAN7_8_SetHigh()            do { LATDbits.LATD0 = 1; } while(0)
#define CHAN7_8_SetLow()             do { LATDbits.LATD0 = 0; } while(0)
#define CHAN7_8_Toggle()             do { LATDbits.LATD0 = ~LATDbits.LATD0; } while(0)
#define CHAN7_8_GetValue()           PORTDbits.RD0
#define CHAN7_8_SetDigitalInput()    do { TRISDbits.TRISD0 = 1; } while(0)
#define CHAN7_8_SetDigitalOutput()   do { TRISDbits.TRISD0 = 0; } while(0)
#define CHAN7_8_SetPullup()          do { WPUDbits.WPUD0 = 1; } while(0)
#define CHAN7_8_ResetPullup()        do { WPUDbits.WPUD0 = 0; } while(0)
#define CHAN7_8_SetPushPull()        do { ODCONDbits.ODCD0 = 0; } while(0)
#define CHAN7_8_SetOpenDrain()       do { ODCONDbits.ODCD0 = 1; } while(0)
#define CHAN7_8_SetAnalogMode()      do { ANSELDbits.ANSD0 = 1; } while(0)
#define CHAN7_8_SetDigitalMode()     do { ANSELDbits.ANSD0 = 0; } while(0)

// get/set CHAN5_6 aliases
#define CHAN5_6_TRIS                 TRISDbits.TRISD1
#define CHAN5_6_LAT                  LATDbits.LATD1
#define CHAN5_6_PORT                 PORTDbits.RD1
#define CHAN5_6_WPU                  WPUDbits.WPUD1
#define CHAN5_6_OD                   ODCONDbits.ODCD1
#define CHAN5_6_ANS                  ANSELDbits.ANSD1
#define CHAN5_6_SetHigh()            do { LATDbits.LATD1 = 1; } while(0)
#define CHAN5_6_SetLow()             do { LATDbits.LATD1 = 0; } while(0)
#define CHAN5_6_Toggle()             do { LATDbits.LATD1 = ~LATDbits.LATD1; } while(0)
#define CHAN5_6_GetValue()           PORTDbits.RD1
#define CHAN5_6_SetDigitalInput()    do { TRISDbits.TRISD1 = 1; } while(0)
#define CHAN5_6_SetDigitalOutput()   do { TRISDbits.TRISD1 = 0; } while(0)
#define CHAN5_6_SetPullup()          do { WPUDbits.WPUD1 = 1; } while(0)
#define CHAN5_6_ResetPullup()        do { WPUDbits.WPUD1 = 0; } while(0)
#define CHAN5_6_SetPushPull()        do { ODCONDbits.ODCD1 = 0; } while(0)
#define CHAN5_6_SetOpenDrain()       do { ODCONDbits.ODCD1 = 1; } while(0)
#define CHAN5_6_SetAnalogMode()      do { ANSELDbits.ANSD1 = 1; } while(0)
#define CHAN5_6_SetDigitalMode()     do { ANSELDbits.ANSD1 = 0; } while(0)

// get/set CHAN3_4 aliases
#define CHAN3_4_TRIS                 TRISDbits.TRISD2
#define CHAN3_4_LAT                  LATDbits.LATD2
#define CHAN3_4_PORT                 PORTDbits.RD2
#define CHAN3_4_WPU                  WPUDbits.WPUD2
#define CHAN3_4_OD                   ODCONDbits.ODCD2
#define CHAN3_4_ANS                  ANSELDbits.ANSD2
#define CHAN3_4_SetHigh()            do { LATDbits.LATD2 = 1; } while(0)
#define CHAN3_4_SetLow()             do { LATDbits.LATD2 = 0; } while(0)
#define CHAN3_4_Toggle()             do { LATDbits.LATD2 = ~LATDbits.LATD2; } while(0)
#define CHAN3_4_GetValue()           PORTDbits.RD2
#define CHAN3_4_SetDigitalInput()    do { TRISDbits.TRISD2 = 1; } while(0)
#define CHAN3_4_SetDigitalOutput()   do { TRISDbits.TRISD2 = 0; } while(0)
#define CHAN3_4_SetPullup()          do { WPUDbits.WPUD2 = 1; } while(0)
#define CHAN3_4_ResetPullup()        do { WPUDbits.WPUD2 = 0; } while(0)
#define CHAN3_4_SetPushPull()        do { ODCONDbits.ODCD2 = 0; } while(0)
#define CHAN3_4_SetOpenDrain()       do { ODCONDbits.ODCD2 = 1; } while(0)
#define CHAN3_4_SetAnalogMode()      do { ANSELDbits.ANSD2 = 1; } while(0)
#define CHAN3_4_SetDigitalMode()     do { ANSELDbits.ANSD2 = 0; } while(0)

// get/set CHAN1_2 aliases
#define CHAN1_2_TRIS                 TRISDbits.TRISD3
#define CHAN1_2_LAT                  LATDbits.LATD3
#define CHAN1_2_PORT                 PORTDbits.RD3
#define CHAN1_2_WPU                  WPUDbits.WPUD3
#define CHAN1_2_OD                   ODCONDbits.ODCD3
#define CHAN1_2_ANS                  ANSELDbits.ANSD3
#define CHAN1_2_SetHigh()            do { LATDbits.LATD3 = 1; } while(0)
#define CHAN1_2_SetLow()             do { LATDbits.LATD3 = 0; } while(0)
#define CHAN1_2_Toggle()             do { LATDbits.LATD3 = ~LATDbits.LATD3; } while(0)
#define CHAN1_2_GetValue()           PORTDbits.RD3
#define CHAN1_2_SetDigitalInput()    do { TRISDbits.TRISD3 = 1; } while(0)
#define CHAN1_2_SetDigitalOutput()   do { TRISDbits.TRISD3 = 0; } while(0)
#define CHAN1_2_SetPullup()          do { WPUDbits.WPUD3 = 1; } while(0)
#define CHAN1_2_ResetPullup()        do { WPUDbits.WPUD3 = 0; } while(0)
#define CHAN1_2_SetPushPull()        do { ODCONDbits.ODCD3 = 0; } while(0)
#define CHAN1_2_SetOpenDrain()       do { ODCONDbits.ODCD3 = 1; } while(0)
#define CHAN1_2_SetAnalogMode()      do { ANSELDbits.ANSD3 = 1; } while(0)
#define CHAN1_2_SetDigitalMode()     do { ANSELDbits.ANSD3 = 0; } while(0)

// get/set CTSn aliases
#define CTSn_TRIS                 TRISDbits.TRISD4
#define CTSn_LAT                  LATDbits.LATD4
#define CTSn_PORT                 PORTDbits.RD4
#define CTSn_WPU                  WPUDbits.WPUD4
#define CTSn_OD                   ODCONDbits.ODCD4
#define CTSn_ANS                  ANSELDbits.ANSD4
#define CTSn_SetHigh()            do { LATDbits.LATD4 = 1; } while(0)
#define CTSn_SetLow()             do { LATDbits.LATD4 = 0; } while(0)
#define CTSn_Toggle()             do { LATDbits.LATD4 = ~LATDbits.LATD4; } while(0)
#define CTSn_GetValue()           PORTDbits.RD4
#define CTSn_SetDigitalInput()    do { TRISDbits.TRISD4 = 1; } while(0)
#define CTSn_SetDigitalOutput()   do { TRISDbits.TRISD4 = 0; } while(0)
#define CTSn_SetPullup()          do { WPUDbits.WPUD4 = 1; } while(0)
#define CTSn_ResetPullup()        do { WPUDbits.WPUD4 = 0; } while(0)
#define CTSn_SetPushPull()        do { ODCONDbits.ODCD4 = 0; } while(0)
#define CTSn_SetOpenDrain()       do { ODCONDbits.ODCD4 = 1; } while(0)
#define CTSn_SetAnalogMode()      do { ANSELDbits.ANSD4 = 1; } while(0)
#define CTSn_SetDigitalMode()     do { ANSELDbits.ANSD4 = 0; } while(0)

// get/set STROBE_RD5 aliases
#define STROBE_RD5_TRIS                 TRISDbits.TRISD5
#define STROBE_RD5_LAT                  LATDbits.LATD5
#define STROBE_RD5_PORT                 PORTDbits.RD5
#define STROBE_RD5_WPU                  WPUDbits.WPUD5
#define STROBE_RD5_OD                   ODCONDbits.ODCD5
#define STROBE_RD5_ANS                  ANSELDbits.ANSD5
#define STROBE_RD5_SetHigh()            do { LATDbits.LATD5 = 1; } while(0)
#define STROBE_RD5_SetLow()             do { LATDbits.LATD5 = 0; } while(0)
#define STROBE_RD5_Toggle()             do { LATDbits.LATD5 = ~LATDbits.LATD5; } while(0)
#define STROBE_RD5_GetValue()           PORTDbits.RD5
#define STROBE_RD5_SetDigitalInput()    do { TRISDbits.TRISD5 = 1; } while(0)
#define STROBE_RD5_SetDigitalOutput()   do { TRISDbits.TRISD5 = 0; } while(0)
#define STROBE_RD5_SetPullup()          do { WPUDbits.WPUD5 = 1; } while(0)
#define STROBE_RD5_ResetPullup()        do { WPUDbits.WPUD5 = 0; } while(0)
#define STROBE_RD5_SetPushPull()        do { ODCONDbits.ODCD5 = 0; } while(0)
#define STROBE_RD5_SetOpenDrain()       do { ODCONDbits.ODCD5 = 1; } while(0)
#define STROBE_RD5_SetAnalogMode()      do { ANSELDbits.ANSD5 = 1; } while(0)
#define STROBE_RD5_SetDigitalMode()     do { ANSELDbits.ANSD5 = 0; } while(0)

// get/set DMM_RESET_RD6 aliases
#define DMM_RESET_RD6_TRIS                 TRISDbits.TRISD6
#define DMM_RESET_RD6_LAT                  LATDbits.LATD6
#define DMM_RESET_RD6_PORT                 PORTDbits.RD6
#define DMM_RESET_RD6_WPU                  WPUDbits.WPUD6
#define DMM_RESET_RD6_OD                   ODCONDbits.ODCD6
#define DMM_RESET_RD6_ANS                  ANSELDbits.ANSD6
#define DMM_RESET_RD6_SetHigh()            do { LATDbits.LATD6 = 1; } while(0)
#define DMM_RESET_RD6_SetLow()             do { LATDbits.LATD6 = 0; } while(0)
#define DMM_RESET_RD6_Toggle()             do { LATDbits.LATD6 = ~LATDbits.LATD6; } while(0)
#define DMM_RESET_RD6_GetValue()           PORTDbits.RD6
#define DMM_RESET_RD6_SetDigitalInput()    do { TRISDbits.TRISD6 = 1; } while(0)
#define DMM_RESET_RD6_SetDigitalOutput()   do { TRISDbits.TRISD6 = 0; } while(0)
#define DMM_RESET_RD6_SetPullup()          do { WPUDbits.WPUD6 = 1; } while(0)
#define DMM_RESET_RD6_ResetPullup()        do { WPUDbits.WPUD6 = 0; } while(0)
#define DMM_RESET_RD6_SetPushPull()        do { ODCONDbits.ODCD6 = 0; } while(0)
#define DMM_RESET_RD6_SetOpenDrain()       do { ODCONDbits.ODCD6 = 1; } while(0)
#define DMM_RESET_RD6_SetAnalogMode()      do { ANSELDbits.ANSD6 = 1; } while(0)
#define DMM_RESET_RD6_SetDigitalMode()     do { ANSELDbits.ANSD6 = 0; } while(0)

// get/set IO_RD7 aliases
#define IO_RD7_TRIS                 TRISDbits.TRISD7
#define IO_RD7_LAT                  LATDbits.LATD7
#define IO_RD7_PORT                 PORTDbits.RD7
#define IO_RD7_WPU                  WPUDbits.WPUD7
#define IO_RD7_OD                   ODCONDbits.ODCD7
#define IO_RD7_ANS                  ANSELDbits.ANSD7
#define IO_RD7_SetHigh()            do { LATDbits.LATD7 = 1; } while(0)
#define IO_RD7_SetLow()             do { LATDbits.LATD7 = 0; } while(0)
#define IO_RD7_Toggle()             do { LATDbits.LATD7 = ~LATDbits.LATD7; } while(0)
#define IO_RD7_GetValue()           PORTDbits.RD7
#define IO_RD7_SetDigitalInput()    do { TRISDbits.TRISD7 = 1; } while(0)
#define IO_RD7_SetDigitalOutput()   do { TRISDbits.TRISD7 = 0; } while(0)
#define IO_RD7_SetPullup()          do { WPUDbits.WPUD7 = 1; } while(0)
#define IO_RD7_ResetPullup()        do { WPUDbits.WPUD7 = 0; } while(0)
#define IO_RD7_SetPushPull()        do { ODCONDbits.ODCD7 = 0; } while(0)
#define IO_RD7_SetOpenDrain()       do { ODCONDbits.ODCD7 = 1; } while(0)
#define IO_RD7_SetAnalogMode()      do { ANSELDbits.ANSD7 = 1; } while(0)
#define IO_RD7_SetDigitalMode()     do { ANSELDbits.ANSD7 = 0; } while(0)

// get/set CHAN19_20 aliases
#define CHAN19_20_TRIS                 TRISEbits.TRISE0
#define CHAN19_20_LAT                  LATEbits.LATE0
#define CHAN19_20_PORT                 PORTEbits.RE0
#define CHAN19_20_WPU                  WPUEbits.WPUE0
#define CHAN19_20_OD                   ODCONEbits.ODCE0
#define CHAN19_20_ANS                  ANSELEbits.ANSE0
#define CHAN19_20_SetHigh()            do { LATEbits.LATE0 = 1; } while(0)
#define CHAN19_20_SetLow()             do { LATEbits.LATE0 = 0; } while(0)
#define CHAN19_20_Toggle()             do { LATEbits.LATE0 = ~LATEbits.LATE0; } while(0)
#define CHAN19_20_GetValue()           PORTEbits.RE0
#define CHAN19_20_SetDigitalInput()    do { TRISEbits.TRISE0 = 1; } while(0)
#define CHAN19_20_SetDigitalOutput()   do { TRISEbits.TRISE0 = 0; } while(0)
#define CHAN19_20_SetPullup()          do { WPUEbits.WPUE0 = 1; } while(0)
#define CHAN19_20_ResetPullup()        do { WPUEbits.WPUE0 = 0; } while(0)
#define CHAN19_20_SetPushPull()        do { ODCONEbits.ODCE0 = 0; } while(0)
#define CHAN19_20_SetOpenDrain()       do { ODCONEbits.ODCE0 = 1; } while(0)
#define CHAN19_20_SetAnalogMode()      do { ANSELEbits.ANSE0 = 1; } while(0)
#define CHAN19_20_SetDigitalMode()     do { ANSELEbits.ANSE0 = 0; } while(0)

// get/set IO_RE1 aliases
#define IO_RE1_TRIS                 TRISEbits.TRISE1
#define IO_RE1_LAT                  LATEbits.LATE1
#define IO_RE1_PORT                 PORTEbits.RE1
#define IO_RE1_WPU                  WPUEbits.WPUE1
#define IO_RE1_OD                   ODCONEbits.ODCE1
#define IO_RE1_ANS                  ANSELEbits.ANSE1
#define IO_RE1_SetHigh()            do { LATEbits.LATE1 = 1; } while(0)
#define IO_RE1_SetLow()             do { LATEbits.LATE1 = 0; } while(0)
#define IO_RE1_Toggle()             do { LATEbits.LATE1 = ~LATEbits.LATE1; } while(0)
#define IO_RE1_GetValue()           PORTEbits.RE1
#define IO_RE1_SetDigitalInput()    do { TRISEbits.TRISE1 = 1; } while(0)
#define IO_RE1_SetDigitalOutput()   do { TRISEbits.TRISE1 = 0; } while(0)
#define IO_RE1_SetPullup()          do { WPUEbits.WPUE1 = 1; } while(0)
#define IO_RE1_ResetPullup()        do { WPUEbits.WPUE1 = 0; } while(0)
#define IO_RE1_SetPushPull()        do { ODCONEbits.ODCE1 = 0; } while(0)
#define IO_RE1_SetOpenDrain()       do { ODCONEbits.ODCE1 = 1; } while(0)
#define IO_RE1_SetAnalogMode()      do { ANSELEbits.ANSE1 = 1; } while(0)
#define IO_RE1_SetDigitalMode()     do { ANSELEbits.ANSE1 = 0; } while(0)

// get/set SENSE_ENn aliases
#define SENSE_ENn_TRIS                 TRISEbits.TRISE2
#define SENSE_ENn_LAT                  LATEbits.LATE2
#define SENSE_ENn_PORT                 PORTEbits.RE2
#define SENSE_ENn_WPU                  WPUEbits.WPUE2
#define SENSE_ENn_OD                   ODCONEbits.ODCE2
#define SENSE_ENn_ANS                  ANSELEbits.ANSE2
#define SENSE_ENn_SetHigh()            do { LATEbits.LATE2 = 1; } while(0)
#define SENSE_ENn_SetLow()             do { LATEbits.LATE2 = 0; } while(0)
#define SENSE_ENn_Toggle()             do { LATEbits.LATE2 = ~LATEbits.LATE2; } while(0)
#define SENSE_ENn_GetValue()           PORTEbits.RE2
#define SENSE_ENn_SetDigitalInput()    do { TRISEbits.TRISE2 = 1; } while(0)
#define SENSE_ENn_SetDigitalOutput()   do { TRISEbits.TRISE2 = 0; } while(0)
#define SENSE_ENn_SetPullup()          do { WPUEbits.WPUE2 = 1; } while(0)
#define SENSE_ENn_ResetPullup()        do { WPUEbits.WPUE2 = 0; } while(0)
#define SENSE_ENn_SetPushPull()        do { ODCONEbits.ODCE2 = 0; } while(0)
#define SENSE_ENn_SetOpenDrain()       do { ODCONEbits.ODCE2 = 1; } while(0)
#define SENSE_ENn_SetAnalogMode()      do { ANSELEbits.ANSE2 = 1; } while(0)
#define SENSE_ENn_SetDigitalMode()     do { ANSELEbits.ANSE2 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCCF5 pin functionality
 * @Example
    IOCCF5_ISR();
 */
void IOCCF5_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCCF5 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCCF5 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF5_SetInterruptHandler(MyInterruptHandler);

*/
void IOCCF5_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCCF5 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCCF5_SetInterruptHandler() method.
    This handler is called every time the IOCCF5 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF5_SetInterruptHandler(IOCCF5_InterruptHandler);

*/
extern void (*IOCCF5_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCCF5 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCCF5_SetInterruptHandler() method.
    This handler is called every time the IOCCF5 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF5_SetInterruptHandler(IOCCF5_DefaultInterruptHandler);

*/
void IOCCF5_DefaultInterruptHandler(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/