
#include "globals.h"
#include "externals.h"
#include "utils.h"

#include "stdbool.h"

#include "mcc_generated_files/mcc.h"


bool relays_are_all_channels_off(void) {
    //Test if all relays are off
    if( (LATA&0x3C)==0x3C &&
        (LATA&0x03)==0x00 &&
        (LATB&0x20)==0x20 &&
        (LATC&0x06)==0x00 &&
        (LATD&0x0F)==0x0F &&
        (LATE&0x01)==0x01  ) {
        return true;
    }
    return false;
}


void relays_open_all_20_channels(void) {
    //PortA
    //BANK2_EVEN_SetLow();
    //BANK2_ODD_SetLow();
    //CHAN11_12_SetHigh();
    //CHAN13_14_SetHigh();
    //CHAN15_16_SetHigh();
    //CHAN17_18_SetHigh();
    //TWO_WIRE_ENn_LAT unchanged.
    LATA = (LATA & 0xFC) | 0x3C;
    
    //PortB
    CHAN9_10_SetHigh();
    
    //PortC
    //BANK1_EVEN_SetLow();
    //BANK1_ODD_SetLow();
    LATC = LATC & 0xF9;
    
    //PortD
    //CHAN1_2_SetHigh();
    //CHAN3_4_SetHigh();
    //CHAN5_6_SetHigh();
    //CHAN7_8_SetHigh();
    INTERRUPT_GlobalInterruptDisable();
    LATD = LATD | 0x0F; //Watch out for CTS if using flow control in interrupt
    INTERRUPT_GlobalInterruptEnable();
    
    //PortE
    CHAN19_20_SetHigh();
}
